/****************************************************************************** 
 *                      Sources BCB - www.developpez.com                      * 
 * -------------------------------------------------------------------------- * 
 *                                                                            *
 * FractalDemo.cpp                                                            *
 * Version : 1.0.0 mise  jour le 11 avril 2005                               *
 * Copyright Cryptonyx 2005 (http://five.chez.tiscali.fr)                     *
 *                                                                            * 
 * Test avec:                                                                * 
 * SE: WinXP                                                                  *
 * IDE: BCB6                                                                  *
 *                                                                            * 
 * -------------------------------------------------------------------------- * 
 *                                                                            *
 * Algorithmes de cration de fractales                                       *
 *                                                                            *
 * -------------------------------------------------------------------------- * 
 *                                                                            * 
 * Retrouvez d'autres ressources BCB sur :                                    * 
 *  - http://c.developpez.com/sources/bcb/                                    * 
 *  - http://c.developpez.com/faq/bcb/                                        * 
 * Ainsi que sur les forums (http://www.developpez.net/forums/)               * 
 *                                                                            * 
 ******************************************************************************/

#include <vcl.h>
#pragma hdrstop

#include "FractalDemo.h"
#include "About.h"
#include "Information.h"
#include "Options.h"
#include "ColorTest.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TBackGround *BackGround;
//---------------------------------------------------------------------------
__fastcall TBackGround::TBackGround(TComponent* Owner)
   : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TBackGround::FormCreate(TObject *Sender)
{
   // cre un objet de la classe Fractal
   Fractal = new TFractal;
   // cre un Bitmap et lui affecte la taille de l'cran - le contenu est blanc
   Bitmap = new Graphics::TBitmap();
   Bitmap->Width = Width;
   Bitmap->Height = Height;
   // la fractale est dessine dans le Bitmap puis affiche  la fin du calcul
   Fractal->InitDrawArea(Bitmap->Canvas, clRed, Width, Height);
   // la fractale est affiche directement (plus lent et risque de perte si on change d'application)
//   Fractal->InitDrawArea(Canvas, clRed, Width, Height);
   Fractal->Formula(fFirstRemainderTest);
}

//---------------------------------------------------------------------------
void __fastcall TBackGround::AboutMenuItemClick(TObject *Sender)
{
   AboutBox->ShowModal();   
   Canvas->Draw(0, 0, Bitmap);
}
//---------------------------------------------------------------------------
void __fastcall TBackGround::HelpMenuItemClick(TObject *Sender)
{
   HelpBox->ShowModal();
   Canvas->Draw(0, 0, Bitmap);
}

//---------------------------------------------------------------------------
// DoJuliaClick
//   dessine une fractale de Julia
//---------------------------------------------------------------------------
void __fastcall TBackGround::DoJuliaClick(TObject *Sender)
{
   SelectBox->Fractal = Fractal;
   SelectBox->ZoomLabel->Caption = "Zoom";
   SelectBox->SetSize->Caption = "Borne";
   SelectBox->ZoomEdit->Text = "200";
   SelectBox->SetSizeValue->Text = "200";
   SelectBox->RDisplay->Caption = "Partie relle de Z";
   SelectBox->IDisplay->Caption = "Partie imaginaire de Z";
   SelectBox->RInput->Text = "0,5";
   SelectBox->IInput->Text = "-0,5";
   SelectBox->XInput->Enabled = true;
   SelectBox->YInput->Enabled = true;
   SelectBox->CenterButton->Enabled = true;
   SelectBox->ColorPick->Color = Fractal->BaseColor;
   if(SelectBox->ShowModal() == mrOk) {
      Cursor = crHourGlass;
      Fractal->XDecay = StrToInt(SelectBox->XInput->Text);
      Fractal->YDecay = StrToInt(SelectBox->YInput->Text);
      Fractal->realZ = StrToFloat(SelectBox->RInput->Text);
      Fractal->imagZ = StrToFloat(SelectBox->IInput->Text);
      Fractal->realC = StrToFloat(SelectBox->RInput->Text);
      Fractal->imagC = StrToFloat(SelectBox->IInput->Text);
      Fractal->Zoom = StrToFloat(SelectBox->ZoomEdit->Text);
      Fractal->SetSize = StrToInt(SelectBox->SetSizeValue->Text) * StrToInt(SelectBox->SetSizeValue->Text);
      if(Fractal->SetSize == 0)
         Fractal->SetSize = 1000;
      Fractal->GenerateJuliaFractal();
      Cursor = crDefault;
   }
   Canvas->Draw(0, 0, Bitmap);
}

//---------------------------------------------------------------------------
// DoMandelbrotClick
//   dessine une fractale de Mandelbrot
//---------------------------------------------------------------------------
void __fastcall TBackGround::DoMandelbrotClick(TObject *Sender)
{
   SelectBox->Fractal = Fractal;
   SelectBox->ZoomLabel->Caption = "Zoom";
   SelectBox->SetSize->Caption = "Borne";
   SelectBox->ZoomEdit->Text = "200";
   SelectBox->SetSizeValue->Text = "200";
   SelectBox->RDisplay->Caption = "Partie relle de C";
   SelectBox->IDisplay->Caption = "Partie imaginaire de C";
   SelectBox->RInput->Text = "0,31";
   SelectBox->IInput->Text = "-0,002";
   SelectBox->XInput->Enabled = true;
   SelectBox->YInput->Enabled = true;
   SelectBox->CenterButton->Enabled = true;
   SelectBox->ColorPick->Color = Fractal->BaseColor;
   if(SelectBox->ShowModal() == mrOk) {
      Cursor = crHourGlass;
      Fractal->XDecay = StrToInt(SelectBox->XInput->Text);
      Fractal->YDecay = StrToInt(SelectBox->YInput->Text);
      Fractal->realZ = StrToFloat(SelectBox->RInput->Text);
      Fractal->imagZ = StrToFloat(SelectBox->IInput->Text);
      Fractal->realC = StrToFloat(SelectBox->RInput->Text);
      Fractal->imagC = StrToFloat(SelectBox->IInput->Text);
      Fractal->Zoom = StrToFloat(SelectBox->ZoomEdit->Text);
      Fractal->SetSize = StrToInt(SelectBox->SetSizeValue->Text) * StrToInt(SelectBox->SetSizeValue->Text);
      if(Fractal->SetSize == 0)
         Fractal->SetSize = 1000;
      Fractal->GenerateMandelbrotFractal();
      Cursor = crDefault;
   }
   Canvas->Draw(0, 0, Bitmap);
}

//---------------------------------------------------------------------------
// DoLyapounovClick
//   dessine une fractale de Lyapounov
//---------------------------------------------------------------------------
void __fastcall TBackGround::DoLyapounovClick(TObject *Sender)
{
   SelectBox->Fractal = Fractal;
   SelectBox->ZoomLabel->Caption = "Itrations X";
   SelectBox->SetSize->Caption = "Itrations Y";
   SelectBox->ZoomEdit->Text = "400";
   SelectBox->SetSizeValue->Text = "800";
   SelectBox->RDisplay->Visible = false;
   SelectBox->IDisplay->Visible = false;
   SelectBox->RInput->Visible = false;
   SelectBox->IInput->Visible = false;
   SelectBox->XInput->Visible = false;
   SelectBox->YInput->Visible = false;
   SelectBox->XDisplay->Visible = false;
   SelectBox->YDisplay->Visible = false;
   SelectBox->CenterButton->Visible = false;
   SelectBox->ColorPick->Color = Fractal->BaseColor;
   if(SelectBox->ShowModal() == mrOk) {
      Cursor = crHourGlass;
      Fractal->IterationX = StrToInt(SelectBox->ZoomEdit->Text);
      Fractal->IterationY = StrToInt(SelectBox->SetSizeValue->Text);
      Fractal->GenerateLyapounovFractal();
      Cursor = crDefault;
   }
   Canvas->Draw(0, 0, Bitmap);
   SelectBox->RDisplay->Visible = true;
   SelectBox->IDisplay->Visible = true;
   SelectBox->RInput->Visible = true;
   SelectBox->IInput->Visible = true;
   SelectBox->XInput->Visible = true;
   SelectBox->YInput->Visible = true;
   SelectBox->XDisplay->Visible = true;
   SelectBox->YDisplay->Visible = true;
   SelectBox->CenterButton->Visible = true;
}
//---------------------------------------------------------------------------

void __fastcall TBackGround::QuitClick(TObject *Sender)
{
   delete Fractal;
   delete Bitmap;
   Close();
}

//---------------------------------------------------------------------------
// LoadClick
//   charge une image au format jpeg
//---------------------------------------------------------------------------
void __fastcall TBackGround::LoadClick(TObject *Sender)
{
TJPEGImage *jpegFractal = new TJPEGImage();

   OpenPictureDialog->DefaultExt = "jpg";
   OpenPictureDialog->FileName = GraphicFileMask(__classid(TJPEGImage));
   OpenPictureDialog->Filter = "Images JPEG | *.jpg";

   if(OpenPictureDialog->Execute()) {
      if(!OpenPictureDialog->Options.Contains(ofExtensionDifferent)) {
        jpegFractal->LoadFromFile(OpenPictureDialog->FileName);
        Bitmap->Assign(jpegFractal);
      }
   }
   Canvas->Draw(0, 0, Bitmap);
   delete jpegFractal;
}

//---------------------------------------------------------------------------
// SaveClick
//   sauve une image au format jpeg
//---------------------------------------------------------------------------
void __fastcall TBackGround::SaveClick(TObject *Sender)
{
TJPEGImage *jpegFractal = new TJPEGImage();

   OpenPictureDialog->DefaultExt = "jpg";
   OpenPictureDialog->FileName = GraphicFileMask(__classid(TJPEGImage));
   OpenPictureDialog->Filter = "Images JPEG | *.jpg";
   if(SavePictureDialog->Execute()) {
      if(!SavePictureDialog->Options.Contains(ofExtensionDifferent)) {
        jpegFractal->Assign(Bitmap);
        jpegFractal->SaveToFile(SavePictureDialog->FileName);
       }
   }
   delete jpegFractal;
   Canvas->Draw(0, 0, Bitmap);
}

//---------------------------------------------------------------------------
void __fastcall TBackGround::ClearClick(TObject *Sender)
{
   Canvas->Pen->Color = clBlack;
   Canvas->FillRect(ClientRect);
}

//---------------------------------------------------------------------------
void __fastcall TBackGround::FormulaClick(TObject *Sender)
{
FractalTest SelectedTest;

   if(TestFormula->ShowModal() == mrOk) {
      switch(TestFormula->Selection) {
         case 1:
            SelectedTest = fFirstRemainderTest;
         break;
         case 2:
           SelectedTest = fSecondRemainderTest;
         break;
         case 3:
            SelectedTest = fThirdRemainderTest;
         break;
         case 4:
           SelectedTest = fSquareRootTest;
         break;
         case 5:
           SelectedTest = fFlatTest;
         break;
         case 6:
           SelectedTest = fSquareTest;
         break;
         case 7:
           SelectedTest = fCubeTest;
         break;
         case 8:
           SelectedTest = fFirstWarp;
         break;
         case 9:
           SelectedTest = fSecondWarp;
         break;
         default:
           SelectedTest = fFlatTest;
         break;
      }
   }
   Fractal->Formula(SelectedTest);
   Canvas->Draw(0, 0, Bitmap);
}

//---------------------------------------------------------------------------
void __fastcall TBackGround::RefreshClick(TObject *Sender)
{
   Canvas->Draw(0, 0, Bitmap);
}

//---------------------------------------------------------------------------
void __fastcall TBackGround::InitLyapounovClick(TObject *Sender)
{
   SelectBox->Fractal = Fractal;
   SelectBox->ZoomLabel->Caption = "Base en X";
   SelectBox->SetSize->Caption = "Base en Y";
   SelectBox->ZoomEdit->Text = "3,54";
   SelectBox->SetSizeValue->Text = "3,45";
   SelectBox->RDisplay->Caption = "Etirement X";
   SelectBox->IDisplay->Caption = "Etirement Y";
   SelectBox->RInput->Text = "1,02";
   SelectBox->IInput->Text = "1,02";
   SelectBox->XDisplay->Caption = "X initial";
   SelectBox->XInput->Text = "0,5";
   SelectBox->XInput->Visible = true;
   SelectBox->YDisplay->Visible = false;
   SelectBox->YInput->Visible = false;
   SelectBox->CenterButton->Visible = false;
   SelectBox->ColorSelection->Visible = false;
   SelectBox->ColorPick->Visible = false;
   if(SelectBox->ShowModal() == mrOk) {
      Cursor = crHourGlass;
      Fractal->XInitValue = StrToFloat(SelectBox->XInput->Text);
      Fractal->XBase = StrToFloat(SelectBox->ZoomEdit->Text);
      Fractal->YBase = StrToFloat(SelectBox->SetSizeValue->Text);
      Fractal->XLat = StrToFloat(SelectBox->RInput->Text);
      Fractal->YLat = StrToFloat(SelectBox->IInput->Text);
      Cursor = crDefault;
   }
   Canvas->Draw(0, 0, Bitmap);
   SelectBox->CenterButton->Visible = true;
   SelectBox->ColorSelection->Visible = true;
   SelectBox->ColorPick->Visible = true;
   SelectBox->YDisplay->Visible = true;
   SelectBox->YInput->Visible = true;
}

