/****************************************************************************** 
 *                      Sources BCB - www.developpez.com                      * 
 * -------------------------------------------------------------------------- * 
 *                                                                            *
 * Fractal.h                                                                  *
 * Version : 1.0.0 mise  jour le 11 avril 2005                               *
 * Copyright Cryptonyx 2005 (http://five.chez.tiscali.fr)                     *
 *                                                                            * 
 * Test avec:                                                                * 
 * SE: WinXP                                                                  *
 * IDE: BCB6                                                                  *
 *                                                                            * 
 * -------------------------------------------------------------------------- * 
 *                                                                            *
 * Algorithmes de cration de fractales                                       *
 *                                                                            *
 * -------------------------------------------------------------------------- * 
 *                                                                            * 
 * Retrouvez d'autres ressources BCB sur :                                    * 
 *  - http://c.developpez.com/sources/bcb/                                    * 
 *  - http://c.developpez.com/faq/bcb/                                        * 
 * Ainsi que sur les forums (http://www.developpez.net/forums/)               * 
 *                                                                            * 
 ******************************************************************************/
//---------------------------------------------------------------------------
#ifndef FractalH
#define FractalH
//---------------------------------------------------------------------------
#include <graphics.hpp>
#include <stdio.h>
//---------------------------------------------------------------------------
enum frTest { fFirstRemainderTest, fSecondRemainderTest, fThirdRemainderTest,
      fSquareRootTest, fFlatTest, fSquareTest, fCubeTest, fFirstWarp, fSecondWarp};
typedef frTest FractalTest;
//--------------------------------------------------------------------------

class TFractal
{
private:
   bool __fastcall ColorSelectionTest();
   double MarkusRoot(int i, double Root1, double Root2);
   int MaxX, MaxY;
   TCanvas *FractalZone;
   FractalTest Test;
public:
   // variables communes  toutes les fractales
   TColor BaseColor;

   // variables pour Mandelbrot et Julia
   FractalTest FractalType;
   int XDecay, YDecay, SetSize;
   float realZ, imagZ;
   float realC, imagC;
   float Zoom;

   // variables pour Markus-Lyapounov
   int IterationX, IterationY;
   double XInitValue, XBase, YBase;
   double XLat, YLat;
   
   void __fastcall InitDrawArea(TCanvas *Canvas, TColor Color, int Width, int Height);
   void __fastcall GenerateMandelbrotFractal();
   void __fastcall GenerateJuliaFractal();
   void __fastcall GenerateLyapounovFractal();
   void __fastcall DrawPoint(int WhereX, int WhereY);
   void __fastcall Formula(FractalTest SelectedTest);
   __fastcall TFractal();
};
//---------------------------------------------------------------------------
#endif
